# Project 1 Interactive Hello World

This project picks up directly from the flashing instructions in the root `README.md`. In this project we will be manually creating all LVGL objects within the REPL. We do this to progressively learn how an LVGL interface is built from a set of parent<->child relationships.

The code within the example assumes an ESP32-S3 DevKitC-1, [pin out diagram is available here](https://docs.espressif.com/projects/esp-idf/en/v5.2.2/esp32s3/hw-reference/esp32s3/user-guide-devkitc-1.html#pin-layout). 

The code also assumes an ili9341 TFT Display with an xpt2046 touch sensor. These boards are inexpensive and available on Amazon or Aliexpress from many distributors.

##  Our pin mapping

The ili9341/xpt2046 uses the Serial Peripheral Interface(SPI) for communication with our board. You should [review the terminology](https://docs.espressif.com/projects/esp-idf/en/v5.2.2/esp32s3/api-reference/peripherals/spi_master.html#terminology) section of the documentation before continuing. The ESP32-S3 has multiple SPI buses (or in Espressif terms 'hosts') some of which are already in use for flash and PSRAM on the devkit. SPI buses 1 and 2 will be used here for our example, each of which will be connected to the ili9341 and xpt2046, with different configured speeds.

### The GPIO Matrix and IO_MUX 

If you are combing through the ESP-IDF documentation you will find references to SPI buses connected to specific GPIO pins. The ESP32-S3 has a flexible I/O system that allows for mapping internal peripherals (e.g. SPI) to GPIO pins. This is achieved via the I/O Multiplexer(IO_MUX) and the GPIO Matrix.

The IO_MUX is a hardware-level multiplexer that connects the chip's internal peripherals to the physical pins. Each GPIO pin has a default peripheral function, which is directly connected through the IO_MUX. Using the IO_MUX provides the fastest and most efficient connection between a peripheral and a pin. This is why you will see in the pin out diagram reference SPI functions like FSPICS0(Chip select) to GPIO pin 10. 

The GPIO Matrix is a programmable routing system that sits between the IO_MUX and the chip's peripherals. It allows almost any internal signal to be routed to almost any GPIO pin. In short it allows us to map the Chip select functionality mentioned above to another pin.

This project makes generous use of the flexible pin assignment capability provided by the GPIO Matrix. Be aware that technically the IO_MUX default pins will provide better performance. Also in Micropython the SPI numbers does not directly map 

## Access the REPL

Assuming no other Micropython serial devices are connected to your PC. Plug your board in and type the command `mpremote`. This should automatically connect to the first device. 
